VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmMain 
   Caption         =   "Marching cube map of studied function"
   ClientHeight    =   7410
   ClientLeft      =   105
   ClientTop       =   975
   ClientWidth     =   8460
   Icon            =   "frmMain2.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   ScaleHeight     =   494
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   564
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   240
      Top             =   5160
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFile_Open_ELD_map 
         Caption         =   "&Open ELD map"
      End
      Begin VB.Menu mnuFile_Save_peak_list 
         Caption         =   "&Save peak list"
      End
      Begin VB.Menu mnuSavePovrayFile 
         Caption         =   "Save &POVRAY file"
      End
      Begin VB.Menu mnuFile_Save_image 
         Caption         =   "Save &image"
      End
      Begin VB.Menu mnuFileExit 
         Caption         =   "&Exit"
      End
   End
   Begin VB.Menu mnuEdit 
      Caption         =   "&Edit"
      Begin VB.Menu mnuEditClearPeaks 
         Caption         =   "&Clear Peaks"
      End
   End
   Begin VB.Menu mnuControl 
      Caption         =   "&View"
      Begin VB.Menu mnuViewShow_Control_Panel 
         Caption         =   "&Show Control Panel"
      End
      Begin VB.Menu mnuViewBackgroundColor 
         Caption         =   "&Background Color"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpHelp 
         Caption         =   "&Help"
      End
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About"
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Marching Cube ELD SGI ver 4 main file
' author Michal Husak husakm@vscht.cz
' Prague Institute of Chemical technology
' comercial use of this code without
' the author agreement is ilegal !!!

Option Explicit

'VARIABLES FOR OpenGL
Dim hPalette As Long
Dim hGLRC As Long
Dim BackgroundColor(1 To 3) As GLfloat

'NEW FOUND PEAKS
Dim NPeaks As Long
Dim Peaks(1 To 200, 1 To 3) As Single ' pozitions of new peaks

'PICKING RESULT
Dim PickResult(1 To 3) As GLfloat ' cordinates of click

'VARIABLES FOR STEREO GEOMETRY
Dim stretchX As Single
Dim stretchY As Single

'SHIFTING VARIABLES
Dim xShift As GLfloat
Dim yShift As GLfloat
Dim zShift As GLfloat
Const step = 0.3

'TRACKBALL VARIABLES
Dim spinning As Boolean, moving As Boolean
Dim beginx As Integer, beginy As Integer
Dim curquat(3) As GLfloat
Dim lastquat(3) As GLfloat
Dim newModel As Boolean
Dim scaling As Boolean
Dim scalefactor As Single
Dim anim As Boolean
Dim StopAll As Boolean

' THE VOXEL FIELD DESCRIPTION
Dim Voxel() As Single ' VOXEL FIELD
'DEBUGING TOOLS

Private Sub Form_Load()
Dim hGLRC As Long
    
  DisplayMode = "Nothing"
  
  LoadAndInitialize Command ' process comand line and initialize variables

  InitializeVariables
      
   'OpenGL INITIALIZATION
    frmMain.ScaleMode = 3 ' we are working in pixel mode
      Select Case DisplayMode
        Case "NoStereo"
            SetupPixelFormat hDC
        Case "StereoHW"
            SetupPixelFormatStereo hDC
        Case "StereoInterlaced"
            SetupPixelFormatStencil hDC
    End Select
    hGLRC = wglCreateContext(hDC)
    wglMakeCurrent hDC, hGLRC
    ZapniGLfunkce
    Osvetli
    glClearColor 0, 0, 0, 0 'black background
      
    ' first frame initialization
    Show
              
    ' main programe cycle
    Do
      'reaction on mouse
      DoEvents
      If StopAll Then Exit Do
      ' animation if mouse moves
     If anim Then animate
    Loop

End Sub
Private Sub Form_Paint()

'Checking GL error as warning
Dim glERROR As Integer
glERROR = glGetError
If glERROR <> GL_NO_ERROR Then
    MsgBox "Warning: OpenGL error nuber:" + Str$(glERROR)
    'Stop
End If
 
'reactivate the depth test
glEnable GL_DEPTH_TEST
        
Select Case DisplayMode

    Case "NoStereo"
                
        glClear GL_COLOR_BUFFER_BIT Or GL_DEPTH_BUFFER_BIT
               
        Kamera "CentralEye"
        glMatrixMode mmModelView
        recalcModelView
        objekt
        
        glFlush
        SwapBuffers hDC  ' double buffer switching
    
    Case "StereoHW"
                  
        'Left Image
        glDrawBuffer GL_BACK_LEFT
        glClear GL_COLOR_BUFFER_BIT Or GL_DEPTH_BUFFER_BIT
        Kamera "LeftEye"
        glMatrixMode mmModelView
        recalcModelView
        objekt
        
        'Raight Image
        glDrawBuffer GL_BACK_RIGHT
        glClear GL_COLOR_BUFFER_BIT Or GL_DEPTH_BUFFER_BIT
        Kamera "RightEye"
        glMatrixMode mmModelView
        recalcModelView
        objekt
        
        glFlush
        SwapBuffers hDC  ' quad buffer switching
    
    Case "StereoInterlaced"
    
        glEnable GL_STENCIL_TEST
         
        glClear GL_COLOR_BUFFER_BIT Or GL_DEPTH_BUFFER_BIT
              
        'Left Image
        glStencilFunc GL_NOTEQUAL, 1, 1 ' draws if stencil <> 1
        Kamera "LeftEye"
        glMatrixMode mmModelView
        recalcModelView
        objekt
        
        'Raight Image
        glStencilFunc GL_EQUAL, 1, 1 ' draws if stencil <> 0
        Kamera "RightEye"
        glMatrixMode mmModelView
        recalcModelView
        objekt
        
        glFlush
        SwapBuffers hDC  'double buffer switching
        
End Select

End Sub
Public Sub objekt()

' we use display list if it is created
If displayListInited = GL_TRUE Then
    glCallList 1
Else
     
     ' display list creation
    glNewList 1, GL_COMPILE_AND_EXECUTE
    glEnable GL_LIGHTING
        
    ' new peaks
    If PickVisible Then
        glColor3f 1, 1, 1
        glPushMatrix
            glTranslatef PickResult(1), PickResult(2), PickResult(3)
            CentrovanaKrychle 0.3
        glPopMatrix
    End If

    If NPeaks > 0 Then DisplayPeaks
    If AtomVisible Then DrawAtoms
    glDisable GL_LIGHTING 'we do not use lighting on lines
        
    Select Case GridType
        Case 1
            SpiderGrid
        Case 2
            TriangleGrid
        Case Else
            Stop ' not defined grid
    End Select
        
    If ContourVisible Then ContourMap
    
    If CellVisible Then DrawCell
    
    glEndList
    displayListInited = GL_TRUE
    
End If
End Sub
Private Sub Form_Resize()
Dim H As GLint, W As GLint
  
    H = frmMain.ScaleHeight
    W = frmMain.ScaleWidth
  
    If H = 0 Or W = 0 Then ' window minimalization check
        H = 1
        W = 1
    End If
  
    stretchX = 1
    stretchY = 1

    If DisplayMode = "StereoInterlaced" Then
        interlace_stencil W, H
    End If
  
    glViewport 0, 0, W, H
     
    If H / W > 1 Then stretchY = H / W
    If H / W < 1 Then stretchX = W / H
    
    Form_Paint
 
End Sub
Public Sub Kamera(eye$)

Dim a As Single
Dim z As Single
Dim dist As Single
a = 6 ' visible part of the space
z = 15 ' Z depth of the space
dist = z * 1.5 ' distance from center of projection to zeroplane
 Select Case eye$
    Case "CentralEyePicking"
        stereoproj_picking -a * stretchX, a * stretchX, -a * stretchY, a * stretchY, z, -z, 0, dist, 0   'same as lef eye zero
    Case "CentralEye"
        stereoproj -a * stretchX, a * stretchX, -a * stretchY, a * stretchY, z, -z, 0, dist, 0   'same as lef eye zero
    Case "LeftEye"
        stereoproj -a * stretchX, a * stretchX, -a * stretchY, a * stretchY, z, -z, 0, dist, -0.31   'lef eye
    Case "RightEye"
        stereoproj -a * stretchX, a * stretchX, -a * stretchY, a * stretchY, z, -z, 0, dist, 0.31   'same as lef eye positive
    End Select
End Sub
Private Sub Form_Unload(Cancel As Integer)

'stops the main cycle
anim = False
' +-------------------------------------------------------------------
' | Release OpenGL if we decide to quit.
' +-------------------------------------------------------------------
    
If NPeaks > 0 Then SavePeaks NPeaks, Peaks ' save new peaks
    
    
    StopAll = True
    If hGLRC <> 0 Then
        wglMakeCurrent 0, 0
        wglDeleteContext hGLRC
    End If
    
    If hPalette <> 0 Then
        DeleteObject hPalette
    End If
    
   frmControlPanel.Hide
   Unload frmControlPanel
   frmHelp.Hide
   Unload frmHelp
   frmAbout.Hide
   Unload frmAbout
   frmProgressBar.Hide
   Unload frmProgressBar
      
   End
    
End Sub

Public Sub GenerateFields()

' generate the triangle field by Marchnig Cube algoritm
Dim Layer As Integer

For Layer = 1 To 3
    If Active(Layer) Then
        GenerateTriangles VoxelDescription, Voxel, Limit(Layer), Layer, Triangles, NumberOfTriangles(Layer)
    End If
Next Layer

' generates 2 D map by Marching Square algoritm
If ContourVisible Then
  For Layer = 1 To 3
    GenerateContour VoxelDescription, Voxel, Limit(Layer), ContourZHight, Layer, Contour, NumberOfContourLines(Layer)
  Next Layer
End If

displayListInited = False ' new diplay list in now nessesery

End Sub

'mause buttton exammination
Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
  On Error Resume Next
  Select Case Button
    Case vbLeftButton
      spinning = False
      anim = False
      moving = True
      beginx = X
      beginy = Y
        If Shift = 1 Then
          scaling = True
          Else
                scaling = False
          End If
    Case vbRightButton
        ExaminePick X, Y
  End Select
End Sub
Private Sub Form_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
  If Button = vbLeftButton Then
     moving = False
     scaling = False
  End If
End Sub
Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim H As GLint, W As GLint
'mouse move examination
  H = frmMain.ScaleHeight
  W = frmMain.ScaleWidth
    
  If scaling Then
    scalefactor = scalefactor * (1 + ((beginy - Y) / H))
    beginx = X
    beginy = Y
    newModel = True
    Form_Paint
    spinning = True
    GoTo konec
  End If
     
  If moving Then
    Trackball lastquat, (2 * beginx - W) / W, (H - 2 * beginy) / H, (2 * X - W) / W, (H - 2 * Y) / H
    beginx = X
    beginy = Y
    spinning = True
    anim = True
  End If
  
konec:
End Sub

Public Sub recalcModelView()
'new modelview based on trackball calculation
  Dim m(15) As GLfloat
  
' If newModel Then
  
  glMatrixMode GL_MODELVIEW
  glLoadIdentity
  
  build_rotmatrix m, curquat
  glMultMatrixf m(0)
  If scalefactor = 1 Then
     glDisable GL_NORMALIZE
     Else
       glEnable GL_NORMALIZE
  End If
  
  glTranslatef xShift, yShift, zShift
  glScalef scalefactor, scalefactor, scalefactor
  
' End If
 newModel = False
 
End Sub
Private Sub animate()
' trackbal animation in the free time
  add_quats lastquat, curquat, curquat
  newModel = True
  Form_Paint
End Sub
Sub DrawCell()

' draw the  lattice cell
  Dim i As Integer
  
  glColor3f 0.5, 0.5, 0.5 'pure white is not suitable for hardcopy
  glLineWidth 2
  glBegin GL_LINE_LOOP
    For i = 1 To 4
        glVertex3f CellEndPoints(i).X, CellEndPoints(i).Y, CellEndPoints(i).z
    Next i
  glEnd
  glBegin GL_LINE_LOOP
    For i = 5 To 8
        glVertex3f CellEndPoints(i).X, CellEndPoints(i).Y, CellEndPoints(i).z
    Next i
  glEnd
  
  glBegin GL_LINES
    glVertex3f CellEndPoints(1).X, CellEndPoints(1).Y, CellEndPoints(1).z
    glVertex3f CellEndPoints(5).X, CellEndPoints(5).Y, CellEndPoints(5).z
    glVertex3f CellEndPoints(2).X, CellEndPoints(2).Y, CellEndPoints(2).z
    glVertex3f CellEndPoints(6).X, CellEndPoints(6).Y, CellEndPoints(6).z
    glVertex3f CellEndPoints(3).X, CellEndPoints(3).Y, CellEndPoints(3).z
    glVertex3f CellEndPoints(7).X, CellEndPoints(7).Y, CellEndPoints(7).z
    glVertex3f CellEndPoints(4).X, CellEndPoints(4).Y, CellEndPoints(4).z
    glVertex3f CellEndPoints(8).X, CellEndPoints(8).Y, CellEndPoints(8).z
  glEnd

End Sub
Sub ContourMap()
  Dim Level As Integer
  Dim i As Long
  Dim j As Long
  Dim x0 As GLfloat
  Dim y0 As GLfloat
  Dim z As GLfloat
  Dim x1 As GLfloat
  Dim y1 As GLfloat
 
  glLineWidth 3
  glBegin GL_LINES
  ' contour map
  For Level = 1 To 3
     glColor3f ContourColor(Level, 1), _
               ContourColor(Level, 2), _
               ContourColor(Level, 3)
    For i = 1 To NumberOfContourLines(Level)
      For j = 1 To 2
        glVertex3f Contour(Level, i, j, 1), _
                   Contour(Level, i, j, 2), _
                   Contour(Level, i, j, 3)
      Next j
    Next i
  Next Level

glEnd
' rectangle around the contour map
' calculating of the position in the space
  x0 = VoxelDescription(4)
  y0 = VoxelDescription(5)
  z = (ContourZHight - 1) * VoxelDescription(9) + VoxelDescription(6)
  x1 = x0 + (VoxelDescription(1) - 1) * VoxelDescription(7)
  y1 = y0 + (VoxelDescription(2) - 1) * VoxelDescription(8)

  glColor3f 0.7, 0.7, 0.7 'pure white is not suitable for hardcopy
  glLineWidth 2
  glBegin GL_LINE_LOOP
    glVertex3f x0, y0, z
    glVertex3f x1, y0, z
    glVertex3f x1, y1, z
    glVertex3f x0, y1, z
  glEnd

End Sub
Sub SpiderGrid()
' spider like 3D web

  Dim Level As Integer
  Dim i As Long
  Dim j As Long
  Dim xs As XYZ ' center of triangle
  
  If DisplayMode = "StereoInterlaced" Then
    glLineWidth 2 'single point lines are not suitable fro interlaced mode
  Else
    glLineWidth 1
  End If
  
  For Level = 1 To 3
    If Active(Level) Then
       
      glColor3f LayerColor(Level, 1), _
                LayerColor(Level, 2), _
                LayerColor(Level, 3)
                            
        For i = 1 To NumberOfTriangles(Level)
          
          
            ' calculating center of the triangle
            xs = Average3Vector(Triangles(Level, i).p(0), Triangles(Level, i).p(1), Triangles(Level, i).p(2))
                            
            glBegin GL_LINE_STRIP
            glVertex3f Triangles(Level, i).p(0).X, _
                        Triangles(Level, i).p(0).Y, _
                        Triangles(Level, i).p(0).z
             glVertex3f xs.X, xs.Y, xs.z
             glVertex3f Triangles(Level, i).p(1).X, _
                        Triangles(Level, i).p(1).Y, _
                        Triangles(Level, i).p(1).z
          glEnd
          glBegin GL_LINES
            glVertex3f xs.X, xs.Y, xs.z
            glVertex3f Triangles(Level, i).p(2).X, _
                       Triangles(Level, i).p(2).Y, _
                       Triangles(Level, i).p(2).z
          glEnd
        Next i
    End If
Next Level
End Sub

Sub TriangleGrid()
  ' triangle like grid
  Dim Level As Integer
  Dim i As Long
  Dim j As Long

  If DisplayMode = "StereoInterlaced" Then
    glLineWidth 2 'single point lines are not suitable for interlaced mode
  Else
    glLineWidth 1
  End If

  For Level = 1 To 3
    If Active(Level) Then
    
      glColor3f LayerColor(Level, 1), _
                LayerColor(Level, 2), _
                LayerColor(Level, 3)
                
         For i = 1 To NumberOfTriangles(Level)
           glBegin GL_LINE_LOOP
             For j = 0 To 2
             
               glVertex3f Triangles(Level, i).p(j).X, _
                          Triangles(Level, i).p(j).Y, _
                          Triangles(Level, i).p(j).z
             Next j
           glEnd
        Next i
    End If
  Next Level

End Sub
Private Sub Form_KeyPress(KeyAscii As Integer)
  Dim m(15) As GLfloat
  Dim mi(15) As GLfloat
    
 build_rotmatrix m, curquat
 InverzMatrix m, mi
 newModel = True
 anim = False
     
  Select Case KeyAscii
        
    Case Asc("h") ' show control panel
           frmControlPanel.Show
    
    Case Asc("q") ' exit the program
            Unload Me
  
    Case Asc("a") ' move forward
      xShift = xShift + mi(2) * step
      yShift = yShift + mi(6) * step
      zShift = zShift + mi(10) * step
     
    Case Asc("s") ' move back
      xShift = xShift - mi(2) * step
      yShift = yShift - mi(6) * step
      zShift = zShift - mi(10) * step
  
    Case Asc("c") 'recenter
      xShift = 0
      yShift = 0
      zShift = 0
      scalefactor = 1
      
    Case Asc("x")
      SetView ("X")
      
    Case Asc("y")
        SetView ("Y")
    
    Case Asc("z")
        SetView ("Z")
        
    Case Asc("-")

        ContourZHight = ContourZHight - 1
        If ContourZHight < 1 Then ContourZHight = 1
        frmControlPanel.Text6.Text = ContourZHight
        frmMain.GenerateFields
       ' frmMain.Refresh
    
    Case Asc("+")

        ContourZHight = ContourZHight + 1
        If ContourZHight > VoxelDescription(3) Then ContourZHight = VoxelDescription(3)
        frmControlPanel.Text6.Text = ContourZHight
        frmMain.GenerateFields
       ' frmMain.Refresh
               
  End Select

Form_Paint

End Sub
Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
  Dim m(15) As GLfloat
  Dim mi(15) As GLfloat
  build_rotmatrix m, curquat
  InverzMatrix m, mi
 
  'shifting using cursor keys
  newModel = True
  anim = False
 
  Select Case KeyCode
    Case vbKeyUp
      xShift = xShift - mi(1) * step
      yShift = yShift - mi(5) * step
      zShift = zShift - mi(9) * step
    Case vbKeyDown
      xShift = xShift + mi(1) * step
      yShift = yShift + mi(5) * step
      zShift = zShift + mi(9) * step
    Case vbKeyRight
      xShift = xShift - mi(0) * step
      yShift = yShift - mi(4) * step
      zShift = zShift - mi(8) * step
    Case vbKeyLeft
      xShift = xShift + mi(0) * step
      yShift = yShift + mi(4) * step
      zShift = zShift + mi(8) * step
    Case vbKeyEscape
       Unload Me
  End Select
  
  Form_Paint
  
End Sub

Private Sub DrawAtoms()
  Dim i As Integer
  Dim at1 As Integer
  Dim at2 As Integer
  Static quadObj As GLUquadric
  quadObj = gluNewQuadric
  'object properties (invisible if not defined !)
  'type of filling LINE,FILL
  gluQuadricDrawStyle quadObj, GLU_FILL
  'type of shading - SMOOTH,FLAT
  gluQuadricNormals quadObj, GLU_SMOOTH
  'vektors INSIDE OUTSIDE - for light calculations ??
  gluQuadricOrientation quadObj, GLU_OUTSIDE
  
  ' atoms as spheres
  For i = 1 To Natoms
    glPushMatrix '2
    AtomColor (AtomNames(i))
    glTranslatef Atoms(i, 1), Atoms(i, 2), Atoms(i, 3)
    Koule quadObj, AtomRadius(AtomNames(i)), 8
    glPopMatrix '2
  Next i

  'bonds as cylinders
  glColor3f 0.7, 0.7, 0.7 'pure white is not usitable for hardcopy
  glDisable GL_LIGHTING
  If DisplayMode = "StereoInterlaced" Then
    glLineWidth 2 'single point lines are not suitable for interlaced mode
  Else
    glLineWidth 1
  End If
    glBegin GL_LINES
      For i = 1 To NBonds
        at1 = Vazby(i, 1)
        at2 = Vazby(i, 2)
        glVertex3f Atoms(at1, 1), Atoms(at1, 2), Atoms(at1, 3)
        glVertex3f Atoms(at2, 1), Atoms(at2, 2), Atoms(at2, 3)
      Next i
    glEnd
  
End Sub
Private Sub DisplayPeaks()
  Dim i As Integer
  Static quadObj2 As GLUquadric
  quadObj2 = gluNewQuadric
  gluQuadricDrawStyle quadObj2, GLU_FILL
  gluQuadricNormals quadObj2, GLU_SMOOTH
  gluQuadricOrientation quadObj2, GLU_OUTSIDE
  
  For i = 1 To NPeaks
      glPushMatrix
        glColor3f 1, 0.6, 0.1 'orange
        glTranslatef Peaks(i, 1), Peaks(i, 2), Peaks(i, 3)
        Koule quadObj2, 0.25, 8
      glPopMatrix
  Next i
    
End Sub

Private Sub ExaminePick(X As Single, Y As Single)
'picking
 
  Dim PickSucces As Boolean
  Dim i As Integer
  ' for 2D picking
  Dim x0 As GLfloat
  Dim y0 As GLfloat
  Dim z As GLfloat
  Dim x1 As GLfloat
  Dim y1 As GLfloat
   
 Select Case PickingMode
   
   Case "2D"
     x0 = VoxelDescription(4)
     y0 = VoxelDescription(5)
     z = (ContourZHight - 1) * VoxelDescription(9) + VoxelDescription(6)
     x1 = x0 + (VoxelDescription(1) - 1) * VoxelDescription(7)
     y1 = y0 + (VoxelDescription(2) - 1) * VoxelDescription(8)
    
    ExamineClick2D X, Y, x0, x1, y0, x1, z, _
    PickResult, PickSucces
    
  Case "3D"
    ExamineClick3D X, Y, Triangles, NumberOfTriangles, _
    Active, PickResult, PickSucces
    
 End Select

 
  If PickSucces Then
    displayListInited = GL_FALSE
    newModel = True
    PickVisible = True
    Form_Paint
    Beep ' audio signal od succes
    Form_Paint
    AddPeakToList PickResult
    PickVisible = False
    displayListInited = GL_FALSE
    Form_Paint
  End If

End Sub

Private Sub AddPeakToList(PickResult)
  Dim Response
  Dim i As Integer
  Response = MsgBox("Add this peak to pek list?", vbYesNo)
  If Response = vbYes Then
    NPeaks = NPeaks + 1
      If NPeaks > 500 Then
        MsgBox ("To many new peaks")
        Stop
      End If
    For i = 1 To 3
      Peaks(NPeaks, i) = PickResult(i)
    Next i
  End If
End Sub

Private Sub LoadAndInitialize(SuggestedFilename As String)
Dim distinguish$
Dim label$

If left$(SuggestedFilename, 9) = "-StereoHW" Then
    DisplayMode = "StereoHW"
    If Len(SuggestedFilename) > 10 Then
        SuggestedFilename = right$(SuggestedFilename, Len(SuggestedFilename) - 10)
    Else
        SuggestedFilename = ""
    End If
End If

If left$(SuggestedFilename, 17) = "-StereoInterlaced" Then
    DisplayMode = "StereoInterlaced"
    If Len(SuggestedFilename) > 18 Then
        SuggestedFilename = right$(SuggestedFilename, Len(SuggestedFilename) - 18)
    Else
        SuggestedFilename = ""
    End If
End If

' default setting of the display mode
' we change disply mode only when it is not initialized
If DisplayMode = "Nothing" Then
    DisplayMode = "NoStereo"
End If

' input filename analysis
If SuggestedFilename = "" Then
    CommonDialog1.Filter = "ELD map files (*.mt1,*.fou,*.grd)|*.mt1;*.fou;*.grd|All files (*.*)|*.*"
    CommonDialog1.ShowOpen
    InputFile$ = CommonDialog1.filename
    Else
        InputFile$ = SuggestedFilename
End If

'for forcing the mode
'DisplayMode = "StereoInterlaced"
'DisplayMode = "StereoHW"
        
If InputFile$ = "" Then
    MsgBox "No input given !!"
    Stop
End If
'show the data file
label$ = "Visualized file: " + InputFile$
frmMain.Caption = label$

  
    distinguish$ = right$(InputFile$, 3)

Select Case distinguish$
    
    Case "mt1", "MT1" 'original CRYSTALS bin input

        ReadDensityBIN1 InputFile$, VoxelDescription, Voxel, _
                   AtomNames, Atoms, Natoms
        
        SetupLaers2 Limit, Active, LayerColor, ContourColor, _
        VoxelDescription(10), VoxelDescription(11)
                   
    Case "fou", "FOU" 'new ASCI CRYSTALS and WinGX input
        ReadDensityASCI1 InputFile$, VoxelDescription, Voxel, _
                   AtomNames, Atoms, Natoms
        
        SetupLaers2 Limit, Active, LayerColor, ContourColor, _
        VoxelDescription(10), VoxelDescription(11)
    
    Case "grd", "GRD" 'XD file
        ReadDensityGRD InputFile$, VoxelDescription, Voxel, _
                   AtomNames, Atoms, Natoms
                   
        ' optimalization of the limits for the GRD type input
        SetupLaers2 Limit, Active, LayerColor, ContourColor, _
        VoxelDescription(10), VoxelDescription(10) + (VoxelDescription(11) / 500)
        
    Case Else
        MsgBox "Strange file extension !!!"
        MsgBox distinguish$
        Stop
  
  End Select
         
  GenerujVazby Atoms, AtomNames, Natoms, Vazby, NBonds

 

  GenerateFields
  'end of data generations

End Sub

Private Sub mnuEditClearPeaks_Click()
    NPeaks = 0
    displayListInited = GL_FALSE
    Form_Paint
End Sub

Private Sub mnuFile_Save_image_Click()
Dim H As GLint, W As GLint
    H = frmMain.ScaleHeight
    W = frmMain.ScaleWidth
    
    CommonDialog1.filename = "ELD_picture.tga"
    CommonDialog1.Filter = "TGA pictures (*.tga)|*.tga"
    CommonDialog1.ShowSave
    SaveImageTga CommonDialog1.filename, W, H
    
End Sub

Private Sub mnuSavePovrayFile_Click()
    CommonDialog1.filename = "MCE_pov.pov"
    CommonDialog1.Filter = "POVRAY files (*.pov)|*.pov|All files (*.*)|*.*"
    CommonDialog1.ShowSave
    SavePovrayFile CommonDialog1.filename
End Sub

Private Sub mnuViewBackgroundColor_Click()
Dim mlColor As Long
CommonDialog1.Flags = cdlCCRGBInit
CommonDialog1.ShowColor
mlColor = CommonDialog1.Color
'red
BackgroundColor(1) = mlColor And &HFF
'green
BackgroundColor(2) = (mlColor \ &H100) And &HFF
'blue
BackgroundColor(3) = (mlColor \ &H10000) And &HFF

glClearColor BackgroundColor(1) / 255, BackgroundColor(2) / 255, BackgroundColor(3) / 255, 0 'barva pozadi - cerna

displayListInited = GL_FALSE
Form_Paint
End Sub

Private Sub mnuViewShow_Control_Panel_Click()
    frmControlPanel.Show
End Sub

Private Sub mnuFile_Open_ELD_map_Click()
    LoadAndInitialize ("")
    InitializeVariables
    Form_Resize
    Form_Paint
End Sub

Private Sub mnuFile_Save_peak_list_Click()
    If NPeaks > 0 Then
        SavePeaks NPeaks, Peaks
    Else
         MsgBox "You do not have any peaks"
    End If
End Sub

Private Sub mnuFileExit_Click()
Unload Me
End Sub

Private Sub mnuHelpAbout_Click()
frmAbout.Show
End Sub

Private Sub mnuHelpHelp_Click()
frmHelp.Show
End Sub

Private Sub InitializeVariables()
Dim i As Integer

 ' stereo variables initialization
 stretchX = 1
 stretchY = 1
 
'rotation variables setting
  spinning = False
  moving = False
  anim = False
  newModel = True
  scaling = False
  
  scalefactor = 1
  xShift = 0
  yShift = 0
  zShift = 0
   
  StopAll = False
  AtomVisible = True
  PickVisible = False
  CellVisible = False
  PickingMode = "3D"
  NPeaks = 0 ' deleting all peaks

  GridType = 1
  For i = 0 To 3
    curquat(i) = 0
    lastquat(i) = 0
  Next i
  
  ' fill file with default setup
  
  InitializeLayerPresets
  
  Trackball curquat, 0, 0, 0, 0
   'rotation and translation is now initialized
   
 displayListInited = GL_FALSE
 
 frmControlPanel.Hide
 Unload frmControlPanel
 frmControlPanel.Show
   
End Sub
Public Sub SetView(Direction As String)
    moving = False
    scaling = False
    anim = False
    Select Case Direction
    Case "X"
        curquat(0) = 0
        curquat(1) = Sqr(0.5)
        curquat(2) = Sqr(0.5)
        curquat(3) = 0
    Case "Y"
        curquat(0) = Sqr(0.5)
        curquat(1) = 0
        curquat(2) = Sqr(0.5)
        curquat(3) = 0
    Case "Z"
        curquat(0) = Sqr(0.5)
        curquat(1) = Sqr(0.5)
        curquat(2) = 0
        curquat(3) = 0
    End Select
    xShift = 0
    yShift = 0
    zShift = 0
   ' scalefactor = 1
    newModel = True
    Form_Paint
End Sub



